VERSION 5.00
Begin VB.UserControl Socket 
   ClientHeight    =   555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   600
   InvisibleAtRuntime=   -1  'True
   Picture         =   "Socket.ctx":0000
   ScaleHeight     =   555
   ScaleWidth      =   600
   Begin VB.TextBox txtConnect 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   1200
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.TextBox txtSocket 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Visible         =   0   'False
      Width           =   855
   End
End
Attribute VB_Name = "Socket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const INVALID_SOCKET = -1
Private Const SOCKET_ERROR = -1

Private Const SOCK_STREAM = 1
Private Const SOCK_DGRAM = 2

Private Const WSAEWOULDBLOCK = 10035

Private Const MAXGETHOSTSTRUCT = 1024

Private Const INADDR_NONE = &HFFFFFFFF
Private Const INADDR_ANY = &H0

Private Const AF_INET = 2
Private Const PF_INET = 2

Private Const SOL_SOCKET = &HFFFF
Private Const SO_LINGER = &H80
Private Const FD_READ = &H1
Private Const FD_WRITE = &H2
Private Const FD_OOB = &H4
Private Const FD_ACCEPT = &H8
Private Const FD_CONNECT = &H10
Private Const FD_CLOSE = &H20
    
'Properties
Private mSocket As Long
Private mAsync As Boolean

'Events
Public Event ConnectionRequest(Socket As Long)
Public Event Connnect()
Public Event DataArrival(Data As String)
Public Event Disconnect()

'Winsock APIs
Private Declare Function SocketAccept Lib "wsock32.dll" Alias "accept" (ByVal s As Long, addr As sockaddr, addrlen As Long) As Long
Private Declare Function bind Lib "wsock32.dll" (ByVal s As Long, addr As sockaddr, ByVal namelen As Long) As Long
Private Declare Function closesocket Lib "wsock32.dll" (ByVal s As Long) As Long
Private Declare Function SocketConnect Lib "wsock32.dll" Alias "connect" (ByVal s As Long, addr As sockaddr, ByVal namelen As Long) As Long
Private Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
Private Declare Function gethostname Lib "wsock32.dll" (ByVal host_name As String, ByVal namelen As Long) As Long
Private Declare Function getservbyname Lib "wsock32.dll" (ByVal serv_name As String, ByVal proto As String) As Long
Private Declare Function htonl Lib "wsock32.dll" (ByVal hostlong As Long) As Long
Private Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Private Declare Function IcmpCreateFile Lib "ICMP.DLL" () As Long
Private Declare Function IcmpCloseHandle Lib "ICMP.DLL" (ByVal lngHandle As Long) As Integer
Private Declare Function IcmpGetLastError Lib "wsock32.dll" Alias "WSAGetLastError" () As Long
Private Declare Function IcmpSendEcho Lib "ICMP.DLL" (ByVal lngHandle As Long, ByVal lIP As Long, strData As String, ByVal intDataLen As Integer, usrOpt As ICMPReqOpt, bytBuff As Byte, ByVal lngRepLen As Long, ByVal lTimeOut As Long) As Long
Private Declare Function inet_addr Lib "wsock32.dll" (ByVal cp As String) As Long
Private Declare Function ntohl Lib "wsock32.dll" (ByVal netlong As Long) As Long
Private Declare Function ntohs Lib "wsock32.dll" (ByVal netshort As Long) As Integer
Private Declare Function recv Lib "wsock32.dll" (ByVal s As Long, ByVal buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Private Declare Function Socket Lib "wsock32.dll" Alias "socket" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
Private Declare Function SocketListen Lib "wsock32.dll" Alias "listen" (ByVal s As Long, ByVal backlog As Long) As Long
Private Declare Function SocketSend Lib "wsock32.dll" Alias "send" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Private Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal s As Long, ByVal hWnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long
Private Declare Function WSACleanup Lib "wsock32.dll" () As Long
Private Declare Function WSAGetLastError Lib "wsock32.dll" () As Long
Private Declare Sub WSASetLastError Lib "wsock32.dll" (ByVal iError As Long)
Private Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSADATA) As Long
Private Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (xDest As Any, xSource As Any, ByVal nbytes As Long)
Private Declare Function setsockopt Lib "wsock32.dll" (ByVal s As Long, ByVal level As Long, ByVal optname As Long, optval As Any, ByVal optlen As Long) As Long

'Unused APIs
'Private Declare Function ioctlsocket Lib "wsock32.dll" (ByVal s As Long, ByVal cmd As Long, argp As Long) As Long
'Private Declare Function getpeername Lib "wsock32.dll" (ByVal s As Long, sName As sockaddr, namelen As Long) As Long
'Private Declare Function getsockname Lib "wsock32.dll" (ByVal s As Long, sName As sockaddr, namelen As Long) As Long
'Private Declare Function getsockopt Lib "wsock32.dll" (ByVal s As Long, ByVal level As Long, ByVal optname As Long, optval As Any, optlen As Long) As Long
'Private Declare Function inet_ntoa Lib "wsock32.dll" (ByVal inn As Long) As Long
'Private Declare Function recvfrom Lib "wsock32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long, from As sockaddr, fromlen As Long) As Long
'Private Declare Function ws_select Lib "wsock32.dll" Alias "select" (ByVal nfds As Long, readfds As fd_set, writefds As fd_set, exceptfds As fd_set, timeout As timeval) As Long
'Private Declare Function sendto Lib "wsock32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long, to_addr As sockaddr, ByVal tolen As Long) As Long
 
'Private Declare Function ShutDown Lib "wsock32.dll" Alias "shutdown" (ByVal s As Long, ByVal how As Long) As Long


'Private Declare Function gethostbyaddr Lib "wsock32.dll" (addr As Long, ByVal addr_len As Long, ByVal addr_type As Long) As Long
'Private Declare Function getservbyport Lib "wsock32.dll" (ByVal Port As Long, ByVal proto As String) As Long
'Private Declare Function getprotobynumber Lib "wsock32.dll" (ByVal proto As Long) As Long
'Private Declare Function getprotobyname Lib "wsock32.dll" (ByVal proto_name As String) As Long

'Private Declare Function WSAIsBlocking Lib "wsock32.dll" () As Long
'Private Declare Function WSAUnhookBlockingHook Lib "wsock32.dll" () As Long
'Private Declare Function WSASetBlockingHook Lib "wsock32.dll" (ByVal lpBlockFunc As Long) As Long
'Private Declare Function WSACancelBlockingCall Lib "wsock32.dll" () As Long
'Private Declare Function WSAAsyncGetServByName Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal serv_name As String, ByVal proto As String, buf As Any, ByVal buflen As Long) As Long
'Private Declare Function WSAAsyncGetServByPort Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal Port As Long, ByVal proto As String, buf As Any, ByVal buflen As Long) As Long
'Private Declare Function WSAAsyncGetProtoByName Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal proto_name As String, buf As Any, ByVal buflen As Long) As Long
'Private Declare Function WSAAsyncGetProtoByNumber Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal number As Long, buf As Any, ByVal buflen As Long) As Long
'Private Declare Function WSAAsyncGetHostByName Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal host_name As String, buf As Any, ByVal buflen As Long) As Long
'Private Declare Function WSAAsyncGetHostByAddr Lib "wsock32.dll" (ByVal hWnd As Long, ByVal wMsg As Long, addr As Long, ByVal addr_len As Long, ByVal addr_type As Long, buf As Any, ByVal buflen As Long) As Long
'Private Declare Function WSACancelAsyncRequest Lib "wsock32.dll" (ByVal hAsyncTaskHandle As Long) As Long
'Private Declare Function WSARecvEx Lib "wsock32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long

'ICMP Handle
Private hICMP As Long

Private Type ICMPReqOpt
    TTL As Byte ' time-to-live
    tos As Byte ' type-of-service
    flags As Byte ' see below
    optsize As Byte ' length of options string
    options As String ' use empty string (haven't figured this yet)
End Type
Private Type ICMPEchoReply
    Address(1 To 4) As Byte ' address of system responding
    status As Long ' error code
    triptime As Long ' time in milliseconds
    datasize As Integer ' buffer size
    reserved As Integer ' not used
    replydata As String ' buffer returned
    ipoptions As ICMPReqOpt ' options structure
End Type
'Type LingerType
'    l_onoff As Integer
    'l_linger As Integer
'End Type


'ICMP error codes
Private Const ICMP_SUCCESS = 0
Private Const ICMP_BUFFER_TOO_SMALL = 11001
Private Const ICMP_NET_UNREACHABLE = 11002
Private Const ICMP_HOST_UNREACHABLE = 11003
Private Const ICMP_DEST_PROT_UNREACHABLE = 11004
Private Const ICMP_DEST_PORT_UNREACHABLE = 11005
Private Const ICMP_NO_RESOURCES = 11006
Private Const ICMP_BAD_OPTION = 11007
Private Const ICMP_HW_ERROR = 11008
Private Const ICMP_PACKET_TOO_BIG = 11009
Private Const ICMP_REQ_TIMED_OUT = 11010
Private Const ICMP_BAD_REQ = 11011
Private Const ICMP_BAD_ROUTE = 11012
Private Const ICMP_TTL_EXPIRED_TRANSMIT = 11013
Private Const ICMP_TTL_EXPIRED_REASSEM = 11014
Private Const ICMP_PARAM_PROBLEM = 11015
Private Const ICMP_SOURCE_QUENCH = 11016
Private Const ICMP_OPTION_TOO_BIG = 11017
Private Const ICMP_BAD_DESTINATION = 11018
Private Const ICMP_ADDRESS_DELETED = 11019
Private Const ICMP_SPEC_MTU_CHANGE = 11020
Private Const ICMP_MTU_CHANGE = 11021
Private Const ICMP_UNLOAD = 11022
Private Const ICMP_GENERAL_FAILURE = 11050
Private Const ICMP_PENDING = 11255

'ICMP flags
Private Const ICMP_FLAG_NO_FRAGMENT = 2

'ICMP type-of-service options
Private Const ICMP_ECHO_REQUEST = 7
Private Const ICMP_END_OF_LIST = 0
Private Const ICMP_SECURITY = 1
Private Const ICMP_LOOSE_SOURCE_ROUTE = &H82
Private Const ICMP_STRICT_SOURCE_ROUTE = &H83
Private Const ICMP_RECORD_ROUTE = &H89
Private Const ICMP_TIMESTAMP = 7
Private Const ICMP_STREAM_id = &H44
Private Const ICMP_NOOP = &H88

Private Const WSADescription_Len = 256
Private Const WSASYS_Status_Len = 128

Private Type WSADATA
    wversion As Integer
    wHighVersion As Integer
    szDescription(0 To WSADescription_Len) As Byte
    szSystemStatus(0 To WSASYS_Status_Len) As Byte
    iMaxSockets As Integer
    imaxudp As Integer
    lpszvenderinfo As Long
End Type

Private Type sockaddr
    sin_family As Integer
    sin_port As Integer
    sin_addr As Long
    sin_zero As String * 8
End Type

Private Const sockaddr_size = 16

Private Type HostEnt
    h_name As Long
    h_aliases As Long
    h_addrtype As Integer
    h_length As Integer
    h_addr_list As Long
End Type

Private Type LingerType
    l_onoff As Integer
    l_linger As Integer
End Type

Private Const hostent_size = 16
Private Const WM_LBUTTONUP = &H202

Public Function Accept(pSocket As Long) As Boolean
    Dim sck As sockaddr
    Dim rc As Long
    
    'Return the port that the call was accepted on
    rc = SocketAccept(pSocket, sck, Len(sck))
    
    If rc <> SOCKET_ERROR Then
        'Store the socket we connected on
        
        If mSocket <> 0 Then closesocket mSocket
        mSocket = rc
        
        'Go into asynchronous receive mode
        If mAsync Then
            rc = WSAAsyncSelect(mSocket, _
                    txtSocket.hWnd, _
                    ByVal WM_LBUTTONUP, _
                    ByVal FD_READ Or FD_CLOSE)
        End If
    End If
    
    'Return the result
    Accept = (rc <> SOCKET_ERROR)
End Function
Public Function Connect(Host As String, Optional Service As String, Optional Port As Long) As Boolean
    Dim s As Long
    Dim SelectOps As Long
    Dim rc As Long
    Dim sck As sockaddr
    
    'Create the socket
    mSocket = Socket(AF_INET, SOCK_STREAM, 0)
    If mSocket <> SOCKET_ERROR Then
        'Populate the socket
        With sck
            .sin_family = AF_INET
            .sin_addr = Resolve(Host)
            If Service <> "" Then
                .sin_port = getservbyname(ByVal Service, ByVal "TCP")
            Else
                .sin_port = htons(Port)
            End If
            .sin_zero = String$(8, 0)
        End With
        
        'Attempt to connect
        rc = SocketConnect(mSocket, sck, Len(sck))
        If rc <> SOCKET_ERROR Then
            If mAsync Then
                'Go into asynchronous mode and trap
                'the  Read and Close events
                rc = WSAAsyncSelect(mSocket, _
                        txtSocket.hWnd, _
                        ByVal WM_LBUTTONUP, _
                        ByVal FD_READ Or FD_CLOSE)
                If rc <> SOCKET_ERROR Then
                    'Fire the Connect event
                    RaiseEvent Connnect
                    
                    Connect = True
                Else
                    Connect = False
                End If
            Else
                'Fire the Connect event
                RaiseEvent Connnect
            
                Connect = True
            End If
        Else
            Connect = False
        End If
    Else
        'The connection was unsuccessful
        Connect = False
    End If
End Function
Public Function Listen(Port As Long) As Boolean
    Dim sck As sockaddr
    Dim rc As Long
    Dim lngOptVal As Long
    
    'Get a new socket
    mSocket = Socket(AF_INET, SOCK_STREAM, 0)
    If mSocket > 0 Then
        'Prepare the socket
        With sck
            .sin_family = AF_INET
            .sin_port = htons(Port)
            .sin_addr = 0
            .sin_zero = String$(8, Chr$(0))
        End With
        'Bind it to the adapter
        rc = bind(mSocket, sck, Len(sck))
        If rc = 0 Then
            'Start listening
            rc = SocketListen(mSocket, 1)
            If rc <> SOCKET_ERROR Then
                'Fire an event when a connectino is made
                
                rc = WSAAsyncSelect(mSocket, _
                        txtConnect.hWnd, _
                        ByVal WM_LBUTTONUP, _
                        FD_ACCEPT)
                Listen = True
                
            Else
                'Could not listen
                Listen = False
            End If
        Else
            'Failed to bind
            Listen = False
        End If
    Else
        'Failed to create socket
        Listen = False
    End If
End Function

Public Sub Disconnect()
    Dim rc As Long
    
    'Close the socket
    If mSocket <> 0 Then
        rc = closesocket(mSocket)
        'debug.print "closesocket: " & rc
        'Raise the Disconnect event
        RaiseEvent Disconnect
    
        mSocket = 0
    
    End If
End Sub
Public Sub Shutdown()
' call this once per application; if you are using multiple controls only one of them
' needs to call this
    Static blnAlreadyShutdown As Boolean
    
    Dim rc As Long
    
   ' If Not blnAlreadyShutdown Then
        'debug.print "calling wsacleanup"
        rc = WSACleanup
        
     '   If rc <> SOCKET_ERROR Then
     '       blnAlreadyShutdown = True
     '       Do
               ' rc = WSACleanup
     '       Loop While rc <> SOCKET_ERROR
     '   End If
   ' End If
End Sub

Private Function ULongToDouble(ByVal ULong As Long) As Double
    If ULong >= 0 Then
        ULongToDouble = CDbl(ULong)
    Else
        ULongToDouble = (4294967296# + ULong)
    End If
End Function
Public Function LocalIP() As String
    Dim buf As String
    Dim rc As Long
    
    'Allocate a buffer
    buf = Space$(255)
    
    'Call the API
    rc = gethostname(buf, Len(buf))
    rc = InStr(buf, vbNullChar)
    
    'Return the host name
    If rc > 0 Then
        LocalIP = Left$(buf, rc - 1)
    Else
        LocalIP = ""
    End If
End Function

Public Function Ping(Address As String, Timeout As Long) As Boolean
    Dim IRO As ICMPReqOpt
    Dim IER As ICMPEchoReply
    Dim Response(1 To 4096) As Byte
    Dim lAddress As Long
    Dim rc As Long
    
    'Start ICMP
    hICMP = IcmpCreateFile()
    
    If hICMP <> 0 Then
        'Convert IP Address
        lAddress = Resolve(Address)
        
        'Build request packet
        With IRO
            .TTL = 64
            .tos = ICMP_ECHO_REQUEST
            .options = ""
            .optsize = Len(IRO.options)
            .flags = ICMP_FLAG_NO_FRAGMENT
        End With
        
        'Call the Ping API
        rc = IcmpSendEcho(hICMP, _
                lAddress, _
                Space$(32), _
                32, _
                IRO, _
                Response(1), _
                UBound(Response), _
                Timeout)
        
        If rc = 0 Then
            'The ping failed
            Ping = False
        Else
            'We could ping the address
            Ping = True
        End If
    
        'Close ICMP
        IcmpCloseHandle hICMP
    Else
        'Unable to initialize ICMP
        Ping = False
    End If
End Function

Public Function Read() As String
    Dim BytesReceived As Long
    Dim buf As String
    Dim buflen As Long
    Dim rc As String
    
    'Allocate a buffer
    buflen = 255
    buf = String$(buflen, Chr$(0))
    
    'Continue reading the data until the buffer is empty
    Do
        BytesReceived = recv(mSocket, ByVal buf, buflen, 0)
        
        'Add to the buffer
        If BytesReceived > 0 Then
            rc = rc & Left$(buf, BytesReceived)
        Else
            Exit Do
        End If
    Loop
    
    'Return the buffer
    Read = rc
End Function
Private Function Resolve(Host As String) As Long
    Dim phe As Long
    Dim heDestHost As HostEnt
    Dim addrList As Long
    Dim rc As Long
    
    'Attempt to resolve by IP first
    rc = inet_addr(ByVal Host)

    'If we couldn't resolve by IP,
    'then try by host name
    If rc = SOCKET_ERROR Then
        phe = gethostbyname(ByVal Host)
        If phe <> 0 Then
            CopyMemory heDestHost, ByVal phe, hostent_size
            CopyMemory addrList, ByVal heDestHost.h_addr_list, 4
            CopyMemory rc, ByVal addrList, heDestHost.h_length
        Else
            rc = INADDR_NONE
        End If
    End If
    
    'Return the address
    Resolve = rc
End Function
Public Function Send(Data As String) As Boolean
    Dim buf As String
    Dim BytesSent As Long
    
    'Send the data
    'BytesSent = SocketSend(mSocket, ByVal Data, Len(Data) + 1, 0)
    BytesSent = SocketSend(mSocket, ByVal Data, Len(Data), 0)
    'debug.print "sent " & BytesSent & " of " & Len(Data)
    'debug.print Data
    'Return the result
    Send = (BytesSent > 0)
End Function
Public Function WhoIs(Domain As String) As String
    'Do this synchronously
    mAsync = False
    
    'Connect to InterNIC on port 43
    If Connect("rs.internic.net", , 43) Then
        'Get the info for the domain
        If Send(Domain & vbCrLf) Then
            'Read the reply
            WhoIs = Read()
        Else
            'We couldn't send the data
            WhoIs = ""
        End If
    Else
        'We couldn't connect
        WhoIs = ""
    End If
End Function

Public Function LocalHost() As String
    Dim buf As String
    Dim rc As Long
    
    'Allocate a buffer
    buf = Space$(255)
    
    'Call the API
    rc = gethostname(buf, Len(buf))
    rc = InStr(buf, vbNullChar)
    
    'Return the host name
    If rc > 0 Then
        LocalHost = Left$(buf, rc - 1)
    Else
        LocalHost = ""
    End If
End Function

Private Sub txtConnect_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Fire the event
    RaiseEvent ConnectionRequest(mSocket)
End Sub
Private Sub txtSocket_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim buf As String * 4000
    Dim BytesReceived As Long
    
    If mSocket > 0 Then
        'Get the data
        BytesReceived = recv(mSocket, ByVal buf, Len(buf), 0)
        'This event will only fire if the socket
        'closes, or if data arrives. If no data
        'is grabbed, then we can assume the socket
        'was disconnected.
        If BytesReceived > 0 Then
            'Append the data to the end of the buffer
            'txtSocket.Text = txtSocket.Text & Left$(buf, BytesReceived)
            'txtSocket.Text = txtSocket.Text & buf
            'Fire the data arrival event
            RaiseEvent DataArrival(Left(buf, BytesReceived))
            
            'Clear the buffer
            'txtSocket.Text = ""
        Else
            'Any error aside from a blocking error
            'means to disconnect
            If WSAGetLastError() <> WSAEWOULDBLOCK Then
                Disconnect
            End If
        End If
    End If
End Sub


Private Sub UserControl_Initialize()
    Dim udtWSAData As WSADATA
    
    'Start off in asynchronous mode
    mAsync = True
    
    'Start Winsock
    If WSAStartup(&H101, udtWSAData) <> 0 Then
        'We couldn't initialize, so raise an error!
        Err.Raise -1
    End If
End Sub

Public Sub Restart()
    Dim udtWSAData As WSADATA
    
    'Start off in asynchronous mode
    mAsync = True
    
    'Start Winsock
    If WSAStartup(&H101, udtWSAData) <> 0 Then
        'We couldn't initialize, so raise an error!
        Err.Raise -1
    End If

End Sub

Private Sub UserControl_Terminate()
    'Close Winsock
    WSACleanup
End Sub

Public Property Get Asynchronous() As Boolean
    Asynchronous = mAsync
End Property
Public Property Let Asynchronous(ByVal vNewValue As Boolean)
    mAsync = vNewValue
End Property
