VERSION 5.00
Begin VB.Form frmOptions 
   Caption         =   "Options"
   ClientHeight    =   3450
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5700
   Icon            =   "frmOptions.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3450
   ScaleWidth      =   5700
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtTimeout 
      Height          =   375
      Left            =   2258
      TabIndex        =   9
      Text            =   "20"
      Top             =   2085
      Width           =   600
   End
   Begin VB.CheckBox chkAutoDownload 
      Caption         =   "Download automatically"
      Height          =   315
      Left            =   3188
      TabIndex        =   7
      Top             =   2160
      Value           =   1  'Checked
      Width           =   1980
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   360
      Left            =   2288
      TabIndex        =   6
      Top             =   2835
      Width           =   1125
   End
   Begin VB.TextBox txtDownloadDir 
      Height          =   375
      Left            =   2258
      TabIndex        =   2
      Text            =   "C:\"
      Top             =   1470
      Width           =   2925
   End
   Begin VB.TextBox txtPass 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   1808
      PasswordChar    =   "*"
      TabIndex        =   1
      Text            =   "XXXX"
      Top             =   855
      Width           =   3375
   End
   Begin VB.TextBox txtNick 
      Height          =   375
      Left            =   1778
      TabIndex        =   0
      Text            =   "XXXX"
      Top             =   240
      Width           =   3420
   End
   Begin VB.Label lblTimeout 
      Caption         =   "Timeout (seconds):"
      Height          =   450
      Left            =   503
      TabIndex        =   8
      Top             =   2070
      Width           =   1545
   End
   Begin VB.Label lblDownloadDir 
      Caption         =   "Download Directory:"
      Height          =   450
      Left            =   503
      TabIndex        =   5
      Top             =   1455
      Width           =   1575
   End
   Begin VB.Label lblPassword 
      Caption         =   "Password:"
      Height          =   450
      Left            =   503
      TabIndex        =   4
      Top             =   840
      Width           =   990
   End
   Begin VB.Label lblNick 
      Caption         =   "Nickname:"
      Height          =   450
      Left            =   503
      TabIndex        =   3
      Top             =   210
      Width           =   990
   End
End
Attribute VB_Name = "frmOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdOK_Click()
    Dim intResponse As Integer
    
    On Error GoTo errorhandler
    
    frmNappier.NapX1.UserName = txtNick
    frmNappier.NapX1.Password = txtPass
    frmNappier.NapX1.DownloadDirectory = txtDownloadDir
    frmNappier.NapX1.TimeOut = CInt(txtTimeout)
    frmNappier.blnAutoDownload = chkAutoDownload
    SaveSetting "Nappier", "General", "Timeout", txtTimeout
    SaveSetting "Nappier", "General", "AutoDownload", CStr(chkAutoDownload)
    SaveSetting "Nappier", "General", "Nickname", txtNick
    SaveSetting "Nappier", "General", "Password", txtPass
    If InStr(1, txtDownloadDir, ":") < 1 Then
        MsgBox "You must specify the full path including the drive."
        txtDownloadDir.SetFocus
        txtDownloadDir.SelStart = 0
        txtDownloadDir.SelLength = Len(txtDownloadDir)

    Else
        If Dir(txtDownloadDir, vbDirectory) = "" Then
            intResponse = MsgBox("Create new directory?", vbYesNo, "Directory not found")
            If intResponse = vbYes Then
                MkDir txtDownloadDir
            'Else
            End If
        End If
        
        txtDownloadDir = CheckDir(txtDownloadDir)
        txtDownloadDir.SetFocus
        txtDownloadDir.SelStart = 0
        txtDownloadDir.SelLength = Len(txtDownloadDir)
    
        If Dir(txtDownloadDir & "Incomplete", vbDirectory) = "" Then
            MkDir txtDownloadDir & "Incomplete"
        End If
        SaveSetting "Nappier", "General", "DownloadDir", txtDownloadDir
        Unload Me
    End If
    Exit Sub
    
errorhandler:
    txtDownloadDir.SetFocus
    txtDownloadDir.SelStart = 0
    txtDownloadDir.SelLength = Len(txtDownloadDir)
    
End Sub

Private Sub Form_Load()
    txtNick = GetSetting("Nappier", "General", "Nickname", "XXXX")
    txtPass = GetSetting("Nappier", "General", "Password", "XXXX")
    txtTimeout = GetSetting("Nappier", "General", "Timeout", "20")
    chkAutoDownload = CInt(GetSetting("Nappier", "General", "AutoDownload", "1"))
    txtDownloadDir = GetSetting("Nappier", "General", "DownloadDir", "C:\")
End Sub
