VERSION 5.00
Object = "{24F70455-5635-11D3-8B2E-0000E8DFE05B}#2.0#0"; "WINSOCKAPI.OCX"
Begin VB.UserControl NapX 
   ClientHeight    =   735
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1215
   ScaleHeight     =   735
   ScaleWidth      =   1215
   Begin WinsockAPI.Socket tcpDownload 
      Left            =   345
      Top             =   285
      _ExtentX        =   1138
      _ExtentY        =   1111
   End
   Begin WinsockAPI.Socket tcpNap 
      Left            =   765
      Top             =   180
      _ExtentX        =   820
      _ExtentY        =   714
   End
   Begin VB.Timer tmrTimeout 
      Left            =   15
      Top             =   330
   End
   Begin VB.Label lblNapX 
      Caption         =   "NapX"
      Height          =   390
      Left            =   60
      TabIndex        =   0
      Top             =   15
      Width           =   480
   End
End
Attribute VB_Name = "NapX"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const npErrServerError = vbObjectError + 1
Const npErrNoTitleArtist = vbObjectError + 2
Const npErrDownload = vbObjectError + 3

Public Event Login()
Public Event StateChanged()
Public Event MOTDChanged(strNewLine As String)
Public Event SearchComplete()
Public Event Timeout()
Public Event DownloadBegin()
Public Event DownloadComplete()
Public Event DownloadAbort()
Public Event DownloadProgressChange(bytBytesDownloaded)
Public Event NewStats()

Private mnpsState As NapStateType
Private mnpcSearchCriteria As clsNapSearchCriteria
Private mcolSearchResults As Collection
Private mnplSpeed As NapLinkType
Private mlngTotalUsers As Long
Private mlngTotalFiles As Long
Private msngTotalGigs As Single
Private mstrMOTD As String
Private mstrVersion As String
Private mstrUserName As String
Private mstrPassword As String
Private mstrPort As String
Private mstrArtist As String
Private mstrTitle As String
Private mstrDownloadFilename As String
Private mstrDownloadChecksum As String
Private mlngDownloadFileSize As Long
Private mintDownloadMinSpeed As Integer
Private mstrDownloadDirectory As String
Private mbytDownloadIndex As Byte
Private mintMaxResults As Integer
Private mlngTimeOut As Long
Private intDownloadFileNum As Integer
Private intNumResponses As Integer
Private bytBytesDownloaded As Long

Public Property Get SearchResults() As Variant
    Set SearchResults = mcolSearchResults
End Property

Public Property Get DownloadIndex() As Byte
    DownloadIndex = mbytDownloadIndex
End Property

Public Property Let DownloadIndex(bytIndex As Byte)
    mbytDownloadIndex = bytIndex
End Property

Public Property Get DownloadMinSpeed() As Integer
    DownloadMinSpeed = mintDownloadMinSpeed
End Property

Public Property Let DownloadMinSpeed(intDownloadMinSpeed As Integer)
    mintDownloadMinSpeed = intDownloadMinSpeed
End Property

Public Property Get Timeout() As Long
    Timeout = mlngTimeOut
End Property

Public Property Let Timeout(lngTimeout As Long)
    mlngTimeOut = lngTimeout
End Property

Public Property Get DownloadChecksum() As String
    DownloadChecksum = mstrDownloadChecksum
End Property

Public Property Let DownloadChecksum(strChecksum As String)
    mstrDownloadChecksum = strChecksum
End Property

Public Property Get DownloadFilename() As String
    DownloadFilename = mstrDownloadFilename
End Property

Public Property Let DownloadFilename(strFilename As String)
    mstrDownloadFilename = strFilename
End Property

Public Property Get DownloadFileSize() As Long
    DownloadFileSize = mlngDownloadFileSize
End Property

Public Property Let DownloadFileSize(strFileSize As Long)
    mlngDownloadFileSize = strFileSize
End Property

Public Property Get DownloadDirectory() As String
    DownloadDirectory = mstrDownloadDirectory
End Property

Public Property Let DownloadDirectory(strDir As String)
    mstrDownloadDirectory = strDir
End Property

Public Property Get MaxResults() As Integer
    MaxResults = mintMaxResults
End Property

Public Property Let MaxResults(intMaxResults As Integer)
    mintMaxResults = intMaxResults
End Property

Public Property Get SearchCriteria() As clsNapSearchCriteria
    Set SearchCriteria = mnpcSearchCriteria
End Property

Public Property Set SearchCriteria(npcSearchCriteria As clsNapSearchCriteria)
    Set mnpcSearchCriteria = npcSearchCriteria
End Property

Public Property Get Port() As String
    Port = mstrPort
End Property

Public Property Let Port(vData As String)
     mstrPort = vData
End Property

Public Property Get MOTD() As String
    MOTD = mstrMOTD
End Property

Public Property Let MOTD(vData As String)
     mstrMOTD = vData
End Property

Public Property Get TotalUsers() As Long
    TotalUsers = mlngTotalUsers
End Property

Public Property Let TotalUsers(lData As Long)
     mlngTotalUsers = lData
End Property

Public Property Get TotalFiles() As Long
    TotalFiles = mlngTotalFiles
End Property

Public Property Let TotalFiles(lData As Long)
     mlngTotalFiles = lData
End Property

Public Property Get TotalGigs() As Single
    TotalGigs = msngTotalGigs
End Property

Public Property Let TotalGigs(sData As Single)
     msngTotalGigs = sData
End Property

Public Property Get UserName() As String
    UserName = mstrUserName
End Property

Public Property Let Artist(ByVal sNewValue As String)
    mstrArtist = sNewValue
End Property

Public Property Get Artist() As String
    Artist = mstrArtist
End Property

Public Property Let Title(ByVal sNewValue As String)
    mstrTitle = sNewValue
End Property

Public Property Get Title() As String
    Title = mstrTitle
End Property



Public Property Let UserName(ByVal sNewValue As String)
    mstrUserName = sNewValue
End Property


Public Property Get Msgs() As Variant
    Set Msgs = mcolMessages
End Property

Public Property Let State(ByVal npsState As NapStateType)
    mnpsState = npsState
End Property

Public Property Get State() As NapStateType
    State = mnpsState
End Property

Public Property Set Msgs(ByVal sNewValue As Variant)
    Set mcolMessages = sNewValue
End Property

Public Property Get Version() As String
    Version = mstrVersion
End Property

Public Property Let Version(ByVal sNewValue As String)
    mstrVersion = sNewValue
End Property

Public Property Get Password() As String
    Password = mstrPassword
End Property

Public Property Let Password(ByVal sNewValue As String)
    mstrPassword = sNewValue
End Property

Public Property Get Speed() As NapLinkType
    Speed = mnplSpeed
End Property

Public Property Let Speed(ByVal sNewValue As NapLinkType)
    mnplSpeed = sNewValue
End Property

Private Sub tcpDownload_Connnect()
    Dim strFilename As String
    Dim blnok As Boolean
    
    'On Error GoTo errorhandler
    
    Close #intDownloadFileNum
    strFilename = ValidFilename(FilePart(DownloadFilename))
    
    DownloadDirectory = CheckDir(DownloadDirectory)
    If Dir(DownloadDirectory & "Incomplete", vbDirectory) = "" Then
        MkDir DownloadDirectory & "Incomplete"
    End If
    intDownloadFileNum = FreeFile
    Open DownloadDirectory & "Incomplete\" & strFilename For Binary As #intDownloadFileNum
    If State = npWaitingForFirewalledDownload Then
        blnok = tcpDownload.send("1")
        Debug.Print blnok
        State = npWaitingForDownloadSend
        RaiseEvent StateChanged
    Else
        'debug.print "waiting for confirm"
        State = npWaitingForDownloadConfirm
        RaiseEvent StateChanged
        Exit Sub
    End If
    Exit Sub
errorhandler:
    If Err.Number = 75 Then 'path/file access error means we already have an incomplete folder
        ' just continue
        Resume Next
    Else
        AbortTransfer
        'Err.Raise npErrDownload, "NapX.Download", "Error downloading file"
    End If
End Sub

Public Sub AbortTransfer()
    Dim strNewDataPort As String
    Dim blnok As Boolean
    
    tcpDownload.Disconnect
    
    State = npready
    bytBytesDownloaded = 0
    SendMessage npDownloadEnd, ""
    RaiseEvent DownloadAbort
End Sub

Private Sub tcpDownload_ConnectionRequest(Socket As Long)
    Dim blnok As Boolean
    Dim strNewDataPort As String

    blnok = tcpDownload.Accept(Socket)

    If blnok Then
        State = npWaitingForDownloadSend
        RaiseEvent StateChanged
        blnok = tcpDownload.send("1")
    End If
End Sub

Private Sub tcpDownload_DataArrival(Data As String)
    Dim i As Integer
    Dim start As Single
    Dim strFilename As String
    Dim blnok As Boolean
    On Error GoTo errorhandler
    
    starttime = Timer
    Select Case State
    Case npWaitingForDownloadSend
        If Left(Data, 4) = "SEND" Then
            State = npWaitingForNameAndSize
        Else
            tcpDownload.Disconnect
            State = npNotConnected
        End If
    Case npWaitingForDownloadConfirm
        If Data = "1" Then
            blnok = tcpDownload.send("GET")
            start = Timer
            While Timer - start < 0.51
                DoEvents
            Wend
            blnok = tcpDownload.send(UserName & " " & Chr(34) & DownloadFilename & _
                        Chr(34) & " 0")
            State = npWaitingForDownloadFileSize
        End If
    Case npWaitingForNameAndSize
        i = 1
        While Not IsNumeric(Mid(Data, i))
            i = i + 1
        Wend
        While IsNumeric(Mid(Data, i, 1))
            i = i + 1
        Wend
        start = Timer
        While (Timer - start) < 0.8
            DoEvents
        Wend
        blnok = tcpDownload.send("0")
        Close #intDownloadFileNum
        strFilename = ValidFilename(FilePart(DownloadFilename))
        DownloadDirectory = CheckDir(DownloadDirectory)
        If Dir(DownloadDirectory & "Incomplete", vbDirectory) = "" Then
            MkDir DownloadDirectory & "Incomplete"
        End If
        intDownloadFileNum = FreeFile
        Open DownloadDirectory & "Incomplete\" & strFilename For Binary As #intDownloadFileNum
        State = npDownloading
        SendMessage npDownloadStart, ""
        RaiseEvent DownloadBegin
    Case npWaitingForDownloadFileSize
        If Not IsNumeric(Left(Data, 1)) Then
            GetMessages Data
        Else
            i = 1
            While IsNumeric(Mid(Data, i, 1))
                i = i + 1
            Wend
            Data = Mid(Data, i)
            Put #intDownloadFileNum, , Data
            State = npDownloading
            SendMessage npDownloadStart, ""
            RaiseEvent DownloadBegin
        End If
    Case npDownloading
        bytBytesDownloaded = bytBytesDownloaded + Len(Data)
        RaiseEvent DownloadProgressChange(bytBytesDownloaded)
        Put #intDownloadFileNum, , Data
        If bytBytesDownloaded >= DownloadFileSize Then
            Close #intDownloadFileNum
            tcpDownload.Disconnect
            DownloadDirectory = CheckDir(DownloadDirectory)
            FileCopy DownloadDirectory & "Incomplete\" & FilePart(DownloadFilename), _
                     DownloadDirectory & FilePart(DownloadFilename)
            Kill DownloadDirectory & "Incomplete\" & FilePart(DownloadFilename)
            RaiseEvent DownloadComplete
            State = npready
            SendMessage npDownloadEnd, ""
            bytBytesDownloaded = 0
        End If
    End Select
    
    starttime = Timer
    Exit Sub
    
errorhandler:
    Resume Next
End Sub

Private Sub tcpNap_Connnect()
    Dim strNapInfo As String
    Dim bytArrayCheckData() As Byte
    
    tmrTimeout.Enabled = True
    tmrTimeout.Interval = 1000
    Select Case State
    Case npWaitingForConnect
        State = npWaitingForRedirect
        RaiseEvent StateChanged
        
    Case npReconnecting
        strNapInfo = UserName & " " & Password & " " & Port & " " & Chr(34) & _
                     Version & Chr(34) & " " & Speed
        State = npLoggingIn
        SendMessage npLogin, strNapInfo
    Case Else
    End Select

End Sub

Private Sub tcpNap_ConnectionRequest(Socket As Long)
    tcpNap.Disconnect
    tcpNap.Accept Socket
End Sub

Private Sub tcpNap_DataArrival(ByRef strData As String)
    Dim strHost As String
    Dim strPort As String
    Dim intColonPos As Integer
    Dim i As Integer
    Dim start As Single
    Dim blnConnected As Boolean
    
    If State <= npready Then starttime = Timer
    Select Case State
    Case npWaitingForRedirect
        strData = Replace(strData, Chr(13), "")
        strData = Replace(strData, Chr(10), "")
        strData = Replace(strData, Chr(0), "")
        intColonPos = InStr(1, strData, ":")
        strHost = Left(strData, intColonPos - 1)
        strPort = Right(strData, Len(strData) - intColonPos)
        tcpNap.Disconnect
        start = Timer
        While Timer - start < 1
            DoEvents
        Wend
        
        State = npReconnecting
        RaiseEvent StateChanged
        blnConnected = tcpNap.Connect(strHost, , CLng(strPort))
    Case npLoggingIn
        GetMessages strData
    Case npready, npWaitingForDownload, npWaitingForFirewalledDownload
        GetMessages strData
    Case Else
        GetMessages strData
    End Select
    starttime = Timer
End Sub

Public Sub HandleMessage(ByVal npmMsgX As clsNapMsg)
    Dim strTokens() As String
    
    Select Case npmMsgX.MsgType
    Case npError
        Err.Raise vbObjectError + 1, "NapX", npmMsgX.Data
        Disconnect
    Case npLoginAck
        RaiseEvent Login
    Case npServerStats
        strTokens = Split(npmMsgX.Data)
        TotalUsers = CLng(strTokens(0))
        TotalFiles = CLng(strTokens(1))
        TotalGigs = CSng(strTokens(2))
        RaiseEvent NewStats
    Case npMOTD
        MOTD = MOTD & npmMsgX.Data & vbCrLf
        RaiseEvent MOTDChanged(npmMsgX.Data)
    Case npSearch
    Case npSearchEnd
        RaiseEvent SearchComplete
    Case npSearchResponse
        GetSearchResults npmMsgX.Data
    Case npDownloadAck
        DownloadFile npmMsgX.Data
    Case npQueueLimit
        AbortTransfer
    Case Else
    
    End Select
    starttime = Timer
End Sub

Public Function GetSearchResults(strData As String) As Boolean
    Dim strTokens() As String
    Dim strFilename As String
    Dim bytQuotePos As Byte
    Dim nprSearchResult As clsNapSearchResult
    Dim dblIP As Double
    
    On Error GoTo errorhandler
    
    bytQuotePos = InStr(2, strData, Chr(34))
    strFilename = Mid(strData, 2, bytQuotePos - 2)
    strData = Mid(strData, bytQuotePos + 1)
    strTokens = Split(strData)
        
    Set nprSearchResult = New clsNapSearchResult
    With nprSearchResult
        .FileName = strFilename
        .MD5 = strTokens(1)
        .Size = CLng(strTokens(2))
        .BitRate = CLng(strTokens(3))
        .Frequency = CLng(strTokens(4))
        .Length = CLng(strTokens(5))
        .Nick = strTokens(6)
        .IP = decodelongipaddr(strTokens(7))
        .LinkType = CByte(strTokens(8))
        .Weight = CInt(strTokens(9))
    End With
    SearchResults.Add nprSearchResult
    Exit Function
    
    GetSearchResults = True
errorhandler:
    GetSearchResults = False
    
End Function

Public Sub DownloadFile(strData As String)
    Dim strTokens() As String
    Dim strFilename As String
    Dim bytOpenQuotePos As Byte
    Dim bytCloseQuotePos As Byte
    Dim nprSearchResult As clsNapSearchResult
    Dim strNick As String
    Dim strMD5 As String
    Dim strIP As String
    Dim strPort As String
    Dim strLinespeed As String
    Dim strMessage As String
    Dim blnok As Boolean
    Dim start As Single
    Dim strNewDataPort As String
    
    bytOpenQuotePos = InStr(1, strData, Chr(34))
    bytCloseQuotePos = InStr(bytOpenQuotePos + 1, strData, Chr(34))
    strFilename = Mid(strData, bytOpenQuotePos + 1, bytCloseQuotePos - bytOpenQuotePos - 1)
    strTokens = Split(Mid(strData, 1, bytOpenQuotePos - 1))
    strNick = strTokens(0)
    strIP = decodelongipaddr(strTokens(1))
    strPort = strTokens(2)
    strTokens = Split(Mid(strData, bytCloseQuotePos + 1))
    strMD5 = strTokens(0)
    strLinespeed = strTokens(1)
    
    If strPort = "0" Then
       strMessage = strNick & " " & Chr(34) & strFilename & Chr(34)
       tcpDownload.Disconnect
       blnok = tcpDownload.Listen(CLng(Port))
       SendMessage npDownloadFirewalled, strMessage
       State = npWaitingForFirewalledDownload
       RaiseEvent StateChanged
    Else
        tcpDownload.Disconnect
        start = Timer
        blnok = tcpDownload.Connect(strIP, , CLng(strPort))
        RaiseEvent StateChanged
    End If
End Sub

Public Sub SendMessage(NapMsgType As NapMsgType, strMessage As String)
    Dim bytType1 As Byte
    Dim bytType2 As Byte
    Dim bytLen1 As Byte
    Dim bytLen2 As Byte
    Dim i As Integer
    Dim blnSent As Boolean
    Dim strBuf As String
    
    bytType1 = CByte(NapMsgType Mod 256)
    bytType2 = CByte(Fix(NapMsgType / 256))
    bytLen1 = CByte(Len(strMessage) Mod 256)
    bytLen2 = CByte(Fix(Len(strMessage) / 256))
    
    strBuf = Chr(bytLen1) & Chr(bytLen2) & Chr(bytType1) & Chr(bytType2) & strMessage
    blnSent = tcpNap.send(strBuf)
End Sub

Public Function Connect() As Boolean
   
    If State <= npWaitingForConnect Then
        
        State = npWaitingForConnect
        RaiseEvent StateChanged
        Connect = tcpNap.Connect("server.napster.com", , 8875)
    End If
End Function

Public Sub Disconnect()
    tcpNap.Disconnect
    tcpDownload.Disconnect
    State = npNotConnected
End Sub

Private Sub tmrTimeout_Timer()
    If Timer - starttime > Timeout And Timeout <> 0 Then
        starttime = Timer
        RaiseEvent Timeout
    End If
End Sub

Private Sub UserControl_Initialize()
    Set mcolSearchResults = New Collection
    Set SearchCriteria = New clsNapSearchCriteria
End Sub

Private Sub UserControl_Terminate()
    tcpNap.Disconnect
    tcpDownload.Disconnect
    Set mcolSearchResults = Nothing
    Set SearchCriteria = Nothing
End Sub

Public Sub Search()
    Dim strSearch As String
    Dim colResults As Collection
    Dim i As Integer
    
    Artist = Trim(Artist)
    Title = Trim(Title)
    
    If MaxResults = 0 Then MaxResults = 100
    If Artist = "" And Title = "" Then
        Err.Raise npErrNoTitleArtist, "NapX.Search", "Must specify Title/Artist for search"
    Else
        If Artist <> "" Then
            strSearch = "FILENAME CONTAINS " & Chr(34) & Artist & Chr(34)
        End If
        
        strSearch = strSearch & " MAX_RESULTS " & CStr(MaxResults)
        
        If Title <> "" Then
            strSearch = strSearch & " FILENAME CONTAINS " & Chr(34) & Title & Chr(34)
        End If
        strSearch = strSearch & " LINESPEED " & Chr(34) & "AT LEAST" & Chr(34) & " " & CStr(DownloadMinSpeed)
        
        For i = 1 To SearchResults.Count
            SearchResults.Remove 1
        Next i
        
        SendMessage npSearch, strSearch
    End If
End Sub

Public Function Download()
    Dim nprMP3Get As clsNapSearchResult
    Dim strMessage As String
    
    On Error GoTo errorhandler
    
    Set nprMP3Get = SearchResults(DownloadIndex)
    nprMP3Get.FileName = Replace(nprMP3Get.FileName, Chr(34) & Chr(34), Chr(34))
    DownloadFilename = nprMP3Get.FileName
    DownloadFileSize = nprMP3Get.Size
    DownloadChecksum = nprMP3Get.MD5
    strMessage = nprMP3Get.Nick & " " & Chr(34) & nprMP3Get.FileName & Chr(34)
    Debug.Print "sending download message"
    SendMessage npDownload, strMessage
    Download = 1
    Exit Function
    
errorhandler:
    Download = 0
    
End Function

Public Sub ProcessByte(ByVal bytIn As Byte)
' process one character at a time
    Dim npmMessageX As clsNapMsg
    Static intByteCount As Integer
    Static lngLen As Long
    Static lngLen1 As Long
    Static lngLen2 As Long
    Static lngType As Long
    Static lngType1 As Long
    Static lngType2 As Long
    Static strMessage As String
    
    intByteCount = intByteCount + 1
    
    Select Case intByteCount
        Case 1:
            lngLen1 = bytIn
        Case 2:
            lngLen = -2
            lngLen2 = bytIn
            lngLen = lngLen1 + lngLen2 * 256
        Case 3:
            lngType1 = bytIn
        Case 4:
            lngType2 = bytIn
            lngType = lngType1 + lngType2 * 256
            If lngLen = 0 Then
                Set npmMessageX = New clsNapMsg
                npmMessageX.Length = lngLen
                If lngType = npMOTD Then
                    strMessage = strMessage & vbCrLf
                End If
                npmMessageX.Data = strMessage
                npmMessageX.MsgType = lngType
                strMessage = ""
                intByteCount = 0
                lngLen = -1
                lngType = -1
                HandleMessage npmMessageX
                Set npmMessageX = Nothing
            End If

        Case Is > 4:
            If intByteCount - 4 >= lngLen Then
                strMessage = strMessage & Chr(bytIn)
                Set npmMessageX = New clsNapMsg
                npmMessageX.Length = lngLen
                If lngType = npMOTD Then
                    strMessage = strMessage & vbCrLf
                End If
                npmMessageX.Data = strMessage
                npmMessageX.MsgType = lngType
                strMessage = ""
                intByteCount = 0
                lngLen = -1
                lngType = -1
                HandleMessage npmMessageX
                Set npmMessageX = Nothing
            Else
                strMessage = strMessage & Chr(bytIn)
            End If
    End Select
End Sub

Public Sub GetMessages(ByVal strData As String)
    Dim intPos As Integer
    
    For intPos = 1 To Len(strData)
        ProcessByte Asc(Mid(strData, intPos, 1))
    Next intPos

End Sub



