VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBillboardChart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function GetBillboardChart(ByVal inetX As Inet, ByVal strURL As String) As Variant
   Dim strHTML As String
   Dim colChart As Collection
   
   On Error GoTo errorhandler
   
   inetX.AccessType = icUseDefault
   strHTML = inetX.OpenURL(strURL)
   
   Set colChart = New Collection
   Set colChart = ParseBillboardChart(strHTML)
   
   Set GetBillboardChart = colChart
   Exit Function
   
errorhandler:
   inetX.Cancel
End Function

Private Function ParseBillboardChart(ByVal strHTML As String) As Variant
'the way the site is designed right now,
'the billboard top 40 page displays the songs in a table
'the lines that contain the artist and song title look like this:
'<font face="geneva,arial" size="-1"><B>&quot;If You're Gone,&quot;</B> matchbox twenty</font>
    Dim songX As clsSong
    Dim colSongs As Collection
    Dim strArtist As String
    Dim strTitle As String
    Dim intStartPos As Integer
    Dim intEndPos As Integer
    
    Set colSongs = New Collection
    
    While InStr(1, strHTML, "&quot") > 0
        intStartPos = InStr(1, strHTML, "&quot") + 4
        strHTML = Mid(strHTML, intStartPos + 2)
        intEndPos = InStr(1, strHTML, ",&quot") - 1
        strTitle = Mid(strHTML, 1, intEndPos)
        
        intStartPos = intEndPos + 13
        intEndPos = InStr(intStartPos + 1, strHTML, "<")
        strArtist = Mid(strHTML, intStartPos, intEndPos - intStartPos)
        
        strHTML = Mid(strHTML, intEndPos + 1)
        
        Set songX = New clsSong
        songX.Artist = strArtist
        songX.Title = strTitle
        colSongs.Add songX
    Wend
    
    Set ParseBillboardChart = colSongs
End Function

